(define-module (mason packages pinephone-keyboard-tools)
  #:use-module ((guix licenses) #:prefix license:)
  #:use-module (guix packages)
  #:use-module (guix utils)
  #:use-module (guix git-download)
  #:use-module (guix build-system gnu)
  #:use-module (guix gexp)
  #:use-module (gnu packages php)
  #:use-module (gnu packages embedded))

(define-public pinephone-keyboard-tools
  (package
    (name "pinephone-keyboard-tools")
    (version "1.0")
    (home-page "https://xff.cz/git/pinephone-keyboard/")
    (source (origin
              (method git-fetch)
              (uri (git-reference
                    (url home-page)
                    (commit version)
                    (recursive? #t)))
              (sha256
               (base32
                "1jsshlid0yr2y9pi1qg66542c7jixclzq881r937fk0fa9bl21j5"))
              (file-name (git-file-name name version))))
    (build-system gnu-build-system)
    (native-inputs
     `(("php" ,php)
       ("sdcc" ,sdcc)))
    (arguments
     `(#:tests? #f
       #:phases
       (modify-phases %standard-phases
         (replace 'configure
           (lambda _
               (setenv "CC" "gcc")
               (substitute* "Makefile"
                 (("VERSION := ")
                   (string-append "VERSION = " ,version "#")))))
         (replace 'install
           (lambda _
            (invoke "mkdir" "-p" 
                (string-append (assoc-ref %outputs "out")
                               "/bin"))
            (invoke "cp" "build/ppkb-i2c-charger-ctl"
                (string-append (assoc-ref %outputs "out")
                               "/bin"))
            (invoke "cp" "build/ppkb-i2c-debugger"
                (string-append (assoc-ref %outputs "out")
                               "/bin"))
            (invoke "cp" "build/ppkb-i2c-flasher"
                (string-append (assoc-ref %outputs "out")
                               "/bin"))
            (invoke "cp" "build/ppkb-i2c-inputd"
                (string-append (assoc-ref %outputs "out")
                               "/bin"))
            (invoke "cp" "build/ppkb-i2c-selftest"
                (string-append (assoc-ref %outputs "out")
                               "/bin"))
            (invoke "cp" "build/ppkb-usb-debugger"
                (string-append (assoc-ref %outputs "out")
                               "/bin"))
            (invoke "cp" "build/ppkb-usb-flasher"
                (string-append (assoc-ref %outputs "out")
                               "/bin"))
               #t)))))
    (synopsis "FOSS Pinephone Keyboard Firmware and Tools")
    (description
     "FOSS Pinephone Keyboard Firmware and Tools")
    (license license:gpl3+)))

pinephone-keyboard-tools
